<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>39.50</title>
</head>

<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách người dùng</h2>

        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    $(document).ready(function () {
        const gDA_COLUMN = [
            "id",
            "firstname",
            "lastname",
            "country",
            "subject",
            "customerType",
            "registerStatus",
            "action",

        ]
        var gUserDataTable =
            $("#user-table").DataTable({
                columns: [
                    { data: gDA_COLUMN[0] },
                    { data: "firstname" },
                    { data: "lastname" },
                    { data: "country" },
                    { data: "subject" },
                    { data: "customerType" },
                    { data: "registerStatus" },
                    { data: "action" }
                ],
                columnDefs: [
                    {
                        targets: 7,
                        defaultContent: `<button class= "btn btn-info user-detail">Chi Tiết</button>`,
                        class: 'text-left'
                    }
                ]
            });
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading()
        $("#user-table").on("click", ".user-detail", function () {
            onBtnUserDetailClick(this)
        });


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            $.ajax({
                url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
                type: "GET",
                dataType: "json",
                success: function (reponseObj) {
                    console.log(Object.entries(reponseObj));
                    console.log(reponseObj);
                    loadDataUsersToTable(reponseObj)
                },
                error: function (error) {
                    console.assert(error.responseText)
                }
            })
        }
        function onBtnUserDetailClick(paramDetailButton) {
            console.log("alo")
            var vTableRow = $(paramDetailButton).parents("tr");
            var vDataTableRow = gUserDataTable.row(vTableRow);
            var vUserObj = vDataTableRow.data();
            console.log(vUserObj)

        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm đổ dữ liệu vào table:
        function loadDataUsersToTable(paramUsers) {
            gUserDataTable.clear();
            gUserDataTable.rows.add(paramUsers);
            gUserDataTable.draw()
        }
    });
</script>

</html>